#!/usr/bin/env python3
#
# Dieses Dokument ist in der Zusammenarbeit von Informatikreferendaren und
# ehemaligen Informatikreferendaren der Studienseminare (heute ZfsL) Arnsberg,
# Hamm und Solingen entstanden.
#
# Das Dokument steht unter der Lizenz: Creative Commons by-nc-sa Version 4.0
# http://creativecommons.org/licenses/by-nc-sa/4.0/deed.de
#
# Nach dieser Lizenz darf das Dokument beliebig kopiert und bearbeitet werden,
# sofern das Folgeprodukt wiederum unter gleichen Lizenzbedingungen vertrieben
# und auf die ursprünglichen Urheber verwiesen wird.
# Eine kommerzielle Nutzung ist ausdrücklich ausgeschlossen.
#
# Die Namensnennung durch einen Verweis und die Lizenzangabe der ursprünglichen
# Urheber auf den Materialien für Schülerinnen und Schüler ist erforderlich.
#
# Die Sammlung der Dokumente steht unter
# http://ddi.uni-wuppertal.de/material/materialsammlung/
# zur Verfügung.
#
# Weitere Lizenz: GPL V3.0
# Siehe http://www.gnu.org/licenses/gpl-3.0.html
#
"""
$Id: vornamenMischSortieren.py 1168 2015-03-21 15:37:18Z humbert $
$HeadURL: svn+ssh://pieper@l119v.studs.math.uni-wuppertal.de/home/mueller/Kooperation/CDG/repos/Materialsammlung/branches/2.1/oberstufe/algorithmen/sortieren/vornamenMischSortieren.py $
$LastChangedDate: 2015-03-21 16:37:18 +0100 (Sa, 21. Mär 2015) $
$LastChangedRevision: 1168 $
$LastChangedBy: humbert $
"""
#
# Quellcode als Musterlösung für das Arbeitsblatt 
# ab_ordnen.tex
# mit Hilfe der ZA-Klasse List in Python
#
from list import List

class MischSortier:
  def __init__(self):
    self.unsortiert= List()
    self.sortiert  = List()
    self.laenge=0
    self.teilstuecklaenge=0

  def fuegeAn(self,element):
    self.unsortiert.append(element)  
    self.laenge= self.laenge+1 

  def mische(self, lisE1, lisE2, lisA):
    """Zwei in sich sortierte Listen (lisE1, lisE2) werden zu einer 
       sortierten Liste (lisA)  verschmolzen"""
    if not lisE1.hasAccess() and not lisE2.hasAccess(): 
      return
      
    if not lisE1.hasAccess(): # lisE1 fertig - lisE2 geht komplett nach lisA
      lisA.concat(lisE2)
      return
            
    if not lisE2.hasAccess(): # lisE2 fertig - lisE1 geht komplett nach lisA
      lisA.concat(lisE1)
      return
    
    kopf1= lisE1.getObject() 
    kopf2= lisE2.getObject()
    
    if kopf1 < kopf2:
      if not lisA.hasAccess():
        lisA.append(kopf1)
      lisA.insert(kopf1)
      lisE1.next()
    else:
      if not lisA.hasAccess():
        lisA.append(kopf2)
      lisA.insert(kopf2)
      lisE2.next()

    self.mische(lisE1, lisE2, lisA)


  def splitList(self, lisE, lisA1, lisA2):
    if not lisE.hasAccess():
      return 
    lisE.toFirst()
    lisA1.append(lisE.getObject())
    #print(lisE.getObject(),"=> A1")
    lisE.remove()

    lisE.toFirst()
    lisA2.append(lisE.getObject())
    #print(lisE.getObject(),"=> A2")
    lisE.remove()

    lisE.toFirst()
    self.splitList(lisE, lisA1, lisA2)
    
    


  def atomareListen(self, ):
    pass


  def mischsortieren(self):
    # Vorbereitung: 
    lisA1=List()
    lisA1.toFirst()
    lisA2=List()
    lisA2.toFirst()
    self.splitList(self.unsortiert, lisA1, lisA2)
    
    
    
if __name__ == "__main__":
  vornamenSortierer= MischSortier()

  vornamenSortierer.fuegeAn("Zeda")
  vornamenSortierer.fuegeAn("Elif")
  vornamenSortierer.fuegeAn("Anne")
  vornamenSortierer.fuegeAn("Renate")
  vornamenSortierer.fuegeAn("Karla") 
  vornamenSortierer.fuegeAn("Britta")
  vornamenSortierer.fuegeAn("Berta")
  vornamenSortierer.fuegeAn("Zander")

  print(vornamenSortierer.unsortiert)
  
  teil1=List()
  teil2=List()
  vornamenSortierer.unsortiert.toFirst()
  
  vornamenSortierer.splitList(vornamenSortierer.unsortiert, teil1, teil2)
  print(teil1, teil2)

  teil1.toFirst()
  teil2.toFirst()

  vornamenSortierer.mische(teil1, teil2, vornamenSortierer.sortiert)
  
  print(vornamenSortierer.sortiert)   


